C       PROGRAM RESPONSE.FOR
C
C         CALCULATE AMPLITUDE RESPONSE AND DELAY FOR INTERPOLATION
C         FILTER
C
        DOUBLE PRECISION G(101,200), XX, YY, DGGRE, DGGIM
        COMPLEX Z,GG
        PI = 3.141592653589
        OPEN(2,FILE='HFIT.DAT')
        OPEN(3,FILE='AMP.DAT')
        OPEN(4,FILE='DELAY.DAT')
        WRITE(*,'(A\)') ' ENTER NUMBER OF TAPS: '
        READ(*,*) NTAPS
        WRITE(*,'(A\)') ' ENTER SAMPLING FREQUENCY:  '
        READ(*,*) FS
        LTAPS = (NTAPS - 1)/2
        WRITE(*,'(A\)') ' ENTER ALPHA: '
        READ(*,*) ALPHA
        DO 2 J=1,NTAPS
        DO 1 I=1,101
1       READ(2,*) TNORM,G(I,J)
2       CONTINUE
C
        IALPHA = 100*ALPHA + 51.
        I = 0
        DO 3 F=0,FS/2.,5
        PI2FFS = 2.*PI*F/FS
        I = I+1
        GG = 0.
        DGGRE=0.
        DGGIM=0.
          DO 4 K=1,NTAPS
          Z = CMPLX(COS(PI2FFS*(K-1)),-SIN(PI2FFS*(K-1)))
         GG = GG + G(IALPHA,K)*Z
         DGGRE = DGGRE - (K-1)*G(IALPHA,K)*SIN(PI2FFS*(K-1))/FS
         DGGIM = DGGIM - (K-1)*G(IALPHA,K)*COS(PI2FFS*(K-1))/FS
4       CONTINUE        
        ABSG = ABS(GG)
        ABSG = MAX(ABSG,1.E-2)
        ABSG = 20.*ALOG10(ABSG)
        WRITE(3,*) F,ABSG
        IF(F.GT.0.AND. F.LE.FS/2.) THEN
        XX = REAL(GG)
        YY = IMAG(GG)
        DELAY = -1.E6*(XX*DGGIM - YY*DGGRE)/(XX**2 +YY**2)
C
C   COMPUTE DELAY RELATIVE TO CENTER TAP (IN MICRO SEC)
C
           DELAY = DELAY - 1.E6*LTAPS/FS
C   SCALE DELAY TO FRACTION OF BAUD           
           DELAY = DELAY * FS*1.E-6
           WRITE(4,*) F,DELAY
        ENDIF
3       CONTINUE
        END
